%     VIRTUAL LAMINATE - программа для получения эффективных свойств слоистых пластин
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Check_Materials_Mech(Materials)

global ErrCode;

fprintf (1, 'Проверка свойств материалов...                          ');

for i=1:size(Materials,1)
    
    if (Materials{i}.ID <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимый номер материала %i !\n', Materials{i}.ID);
        return;
    end
    
    if (Materials{i}.E1 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра E1 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (Materials{i}.E2 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра E2 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (Materials{i}.E3 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра E3 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (Materials{i}.G12 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра G12 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (Materials{i}.G13 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра G13 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (Materials{i}.G23 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение параметра G23 материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    nu12 = Materials{i}.nu12;
    nu13 = Materials{i}.nu13;
    nu23 = Materials{i}.nu23;

    nu21 = nu12 * Materials{i}.E2 / Materials{i}.E1;
    nu31 = nu13 * Materials{i}.E3 / Materials{i}.E1;
    nu32 = nu23 * Materials{i}.E3 / Materials{i}.E2;

    if (1 - nu12*nu21 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: не выполнено соотношение 1 - nu12*nu21 > 0 для материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (1 - nu23*nu32 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: не выполнено соотношение 1 - nu23*nu32 > 0 для материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (1 - nu13*nu31 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: не выполнено соотношение 1 - nu13*nu31 > 0 для материала с номером %i !\n', Materials{i}.ID);
        return;
    end

    if (1 - nu12*nu21 - nu23*nu32 - nu13*nu31 - 2*nu21*nu32*nu13 <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: не выполнено соотношение 1 - nu12*nu21 - nu23*nu32 - nu13*nu31 - 2*nu21*nu32*nu13 > 0 для материала с номером %i !\n', Materials{i}.ID);
        return;
    end
    
    if (Materials{i}.t <= 0)
        ErrCode = -1;
        fprintf (1, '\nОшибка: недопустимое значение толщины слоя материала с номером %i !\n', Materials{i}.ID);
        return;
    end
    
end

fprintf (1, 'OK!\n');
